#include "lfr.h"


LFR::LFR(int videoHeight, int videoWidth, int thresholdBinary, int gaussKernelSize)
    : iAmLooping(false), input(videoHeight, videoWidth), processing(), controlModule(), interpreter(), intersectionHandler()
{
    this->iAmLooping = false;
    this->thresholdBinary = thresholdBinary;
    this->gaussKernelSize = gaussKernelSize;
}

LFR::~LFR()
{
    if(iAmLooping)
    {
        this->endLoop();
    }
}

void LFR::loop()
{
    namedWindow("Display window");
    while(iAmLooping)
    {
        Mat image = input.readFile("C:\\Line-Following-Robot\\Test_data");
        processing.processImage(image, this->thresholdBinary, this->gaussKernelSize);
        std::vector<LFRLine> lines = processing.calculateLineSegments(image);
        imshow("Display window", image);
        char c = (char)waitKey(1);
    }
    destroyWindow("Display window");
    input.freeWebcam();
}

void LFR::startLoop()
{
    iAmLooping = true;
    this->loopThread=thread(&LFR::loop, this);
}

void LFR::endLoop()
{
    iAmLooping = false;
    this->loopThread.join();
    return;
}